const
  Debug______szDebugPipeName = '\\.\pipe\AssasDebugView';

function Debug______Format(fmt: string; params: array of const): string;
var
  pdw1, pdw2: PDWORD;
  i: integer;
  pc: PCHAR;
const
  fmtbufsize = 1024;
begin
  pdw1 := nil;
  if High(params) >= 0 then
    GetMem(pdw1, (High(params) + 1) * sizeof(Pointer));
  pdw2 := pdw1;
  for i := 0 to High(params) do begin
    pdw2^ := PDWORD(@params[i])^;
    inc(pdw2);
  end;
  pc := GetMemory(fmtbufsize);
  if Assigned(pc) then
  try
    SetString(Result, pc, wvsprintf(pc, PCHAR(fmt), PCHAR(pdw1)));
  finally
    if (pdw1 <> nil) then FreeMem(pdw1);
    FreeMem(pc);
  end
  else
    Result := '';
end;

function Debug______GetMyName: string;
var
  buf: array[0..260] of char; // 260 = MAX_PATH
  idx: integer;
begin
  ZeroMemory(@buf, sizeof(buf));
  GetModuleFileName(hInstance, @buf, sizeof(buf));
  for idx := sizeof(buf) - 1 downto 0 do
    if buf[idx] = '\' then break;
  SetString(result, pchar(@buf[idx]), lstrlen(@buf[idx]));
end;

procedure DbgOut(s: string);
var
  hPipe: THandle;
  pc: PChar;
  numWritten: DWORD;
  temps: string;
const
  bufsize = 4096;
begin
  hPipe := CreateFile(Debug______szDebugPipeName, GENERIC_WRITE, 0, nil, OPEN_EXISTING, FILE_FLAG_WRITE_THROUGH, 0);
  if hPipe <> INVALID_HANDLE_VALUE then
  try
    pc := GetMemory(bufsize);
    if Assigned(pc) then
    try
      temps := Debug______Format('[%s -> PID = %d]:  ', [Debug______GetMyName, GetCurrentProcessID]);
      lstrcpyn(pc, @temps[1], bufsize);
      if not (length(s) < (bufsize - lstrlen(pc))) then
        setlength(s, bufsize - lstrlen(pc) - 1);
      lstrcat(pc, @s[1]);
      WriteFile(hPipe, pc^, lstrlen(pc), numWritten, nil);
    finally
      FreeMemory(pc);
    end;
  finally
    CloseHandle(hPipe);
    Sleep(200);
  end;
end;

